# Changelog

## 2022.1 (53)
Features/Improvements:
- Apply filters to Trending Posts
- Don't reload List timelines if Edit screen is closed without changes

Bugfixes:
- Fix URLs getting pasted as broken attachments in the Compose screen
- Fix monspace fonts not adjusting to Dynamic Type setting
- Fix crash when activating account from Preferences when My Profile is opened in a separate window
- Fix Preferences showing wrong account as current when multiple windows with different accounts are open

## 2022.1 (52)
Features/Improvements:
- Save and restore position for all timelines and all accounts
	- As a side effect of this change, the first time you launch with this update, the timeline position will be lost
- Add preference to never blur attachments
- New segmented control for timeline switcher that scrolls when there's not enough space
- Copy status expand all setting when viewing More Replies in a converstaion
- Include followed hashtags in the Explore screen and iPad sidebar
- Allow saving or following hashtag from Add Hashtag screen
- Scroll long attachment descriptions in the gallery
- VoiceOver: Improve Profile Directory
- VoiceOver: Include attachment descriptions in timeline items when not marked as sensitive

Bugfixes:
- Fix swipe actions preference not persisting
- Fix rich text list bullets/numbers appearing black in dark mode
- Fix crash when previewing non-HTTP(S) link
- Fix images from Safari pasting as URLs rather than attachments
- Fix Trending Posts appearing to reload forever
- Fix controls reappearing when swiping between pages in the attachments gallery
- Fix reblog confirmation alert actions missing hover effect
- Fix status reply/visibility/local icons flashing blue when expanding a status
- iPad: Fix My Profile item sidebar item not updating when avatar style changes
- iPad: Fix tapping status bar not scrolling to top in single-column navigation mode
- VoiceOver: Fix crash when scrolling through local/federated timeline
- VoiceOver: Fix escape gesture not working in attachment gallery
- VoiceOver: Fix custom emoji not being stripped from display names

## 2022.1 (51)
Features/Improvements:
- Clarify text for conversation main status favorite/reblog count preference
- Improve timeline refresh behavior
	- Present posts are inserted automatically, creating a gap
	- Tapping the Jump to Present bubble scrolls to the top and removes everything below the gap
- Add preference to disable timeline state restoration (Preferences -> Behavior)
- VoiceOver: Add Jump to Present action on the timeline selector segmented control
- VoiceOver: Add accessibility hint for segmented controls when using the group navigation mode
- VoiceOver: Improve description of timeline gap and add actions to load in a specific direction

Bugfixes:
- Fix crash due to change cache location on disk
- Fix potential crash when trying to restore statuses that aren't available
- Fix saving expired filters not re-enabling them
- Fix tusker:// URL scheme not working
- Fix Trending Posts reloading constantly
- Fix crash when timeline tries to refresh while in the background

## 2022.1 (50)
This is a hotfix for Dynamic Type not working in the timeline. The previous build's changelog is included below.

## 2022.1 (49)
The major new feature of this build is filters! Filters are editable by pressing the Filters button in the top-left corner of the Home tab. Filters are currently applied to timelines and profiles (filtering conversations and notifications will be added in a future build).

Features/Improvements:
- Filters
	- Edit/create filters
	- Apply filters to timelines and profiles
- Add preference to customize swipe actions on status cells (Preferences -> Appearance -> Leading/Trailing Swipe Actions)
- Show notifications for edited posts
- Add more details to the relationship label on profiles
	- "Follows you", "You follow", "You follow each other", and "You block"
- Add state restoration for Federated and Local timelines
	- Also fixes an issue where posts from other timelines would appear in the home timeline after a relaunch
- Add state restoration for Compose screen
- Organize expanded custom emoji picker by category
- Add indicator for locked profiles
- Add cache size info to Advanced preferences
- Indicate when a followed hashtag caused a post to appear in the home timeline
- Add hashtag follow/unfollow actions
- Completely replace timeline items after Jump to Present used
	- Fixes infinite scroll not being usable after jumping
- iPad/Mac: Add Cmd+Return shortcut for sending post on the Compose screen
- VoiceOver: Hide redundant information on Compose screen
- VocieOver: Add links/mentions/hashtags to actions rotor on statuses
- VoiceOver: Add show profile action to timeline statuses

Bugfixes:
- Fix gifv attachments appearing off-center
- Fix long status on certain screens not getting collapsed
- Fix error when refreshing a timeline with no items
- Fix cells in account list and status action account list not being deselected when navigating back
- Limit search in Edit List screen to accounts the user follows
- Fix attachments disappearing from statuses on the Conversation screen
- Fix extra space gap appearing in profile headers below avatar
- Fix mute duration options not including 1 week
- Hometown: Fix local-only state not being copied from the replied-to post
- iPad: Fix timeline statuses not getting deselected when entering split navigation
- iPad: Fix Mute screen using pointless two-column layout
- iPad: Fix creating a list from the sidebar making the previous tab inaccessible
- iPad: Fix creating a list not showing the Edit List screen automatically
- iPad: Fix selected sidebar item becoming out-of-sync when deleting a list/hashtag/instance
- Mac: Workaround for pressing Cmd+1/2/... crashing
	- This prevents the crash, but the actions remain unusable due to a macOS bug
- VoiceOver: Fix escape gesture not working on Compose screen
- VoiceOver: Fix links in conversation main status not being selectable
- VoiceOver: Fix profile relationship not being read
- VoiceOver: Fix not being able to select profile from conversation main status

Known Issues:
- Filters are not applied to notifications and conversations

## 2022.1 (48)
This build is a hotfix for the CW button in the Compose screen not working. The previous build's changelog is attached below.

Bugfixes:
- Fix pressing CW button in Compose not showing the content warning field
- Tweak timeline state restoration to try and maintain the scroll position of the middle item on screen, rather than the top one

## 2022.1 (46)
The headlining feature is state restoration and timeline gaps! When you re-open the app after it's been closed for a while, it will remember your position in the timeline and allow you to keep reading from there. It will also let you jump all the way to the present.

Features/Improvements:
- Timeline state restoration, timeline gaps, and jump-to-present
- Allow posting wide color gamut images on Mastodon 4
- Add Add to List menu action to profiles
- Improve More Actions button visibility on dark profile header images
- Make poll options in the Compose screen reorderable with drag & drop
- Embiggen Share/Close controls in the gallery to make them easier to tap
- Separate section for Shared Albums in the Compose attachment picker
- Indicate verified profile links with a checkmark and popover explaining what it means
- Add a preference for using the Twitter-style keyboard with @ and # (Preferences -> Composing -> Show @ and # on Keyboard)
- Improve reblog indicator in timeline

Bugfixes:
- Fix not being able to select an existing draft to edit it
- Fix double-tap to zoom in the gallery not working
- Fix crash when toggling collapsed posts in Trending Posts
- Fix albums in asset picker not being sorted by name
- Fix profile headers getting squished when statuses are loaded while the profile is offscreen
- Fix error loading posts when server returns rich cards
- Fix Akkoma instnaces not being detected as supporting Pleroma features
- Fix crash when launching the app in slow network conditions
- Fix lists not updating in the UI when renamed
- Fix follow/block/mute actions displaying on the user's own profile
- Fix Edit List screen being presented repeatedly when switching tabs back to Explore with a list open
- Fix reblog visibility icon getting squished in the reblog confirmation dialog when Dynamic Type is active
- Fix toasts not adjusting to Dynamic Type size
- Don't show duplicate reply/favorite/reblog actions in the status More Actions menu
- iPadOS 15: Fix toolbar in Compose window being obscured by the keyboard

## 2022.1 (45)
Features/Improvements:
- iPhone: Temporarily hide the Compose screen by swiping down to access the rest of the applies
- Add Block, Domain Block, and Mute actions to accounts
- Don't change scroll position when switch sections in the Profile screen
- Use URL keyboard in the instance selector and clarify that you can enter any domain
- iPad: Add context menu action for deleting lists in sidebar
- Tweak conditions in which profile fields are shown in a single column, rather than two
- Convert wide color gamut images to sRGB before uploading
	- The Mastodon backend does not support wide-gamut images and does a poor job of conversion, so the conversion is performed locally
- Focus content warning field immediately when CW button is pressed
- Move focus to main text field when return key is pressed while editing the content warning
- Make GIF attachments animate on the Compose screen
- VoiceOver: Make profile fields accessible
- VoiceOver: Only read content warning and not content for CW'd posts
- VoiceOver: Expand collapsed posts when performing double-tap
- VoiceOver: Announce visibility of followers-only & direct posts
- VoiceOver: Make Compose toolbar accessible

Bugfixes:
- Fix tapping links in profile fields
- Fix crash when creating/editing list fails
- Fix renaming a list not updating it elsewhere in the UI
- Fix instance-local/everywhere scope selector in Profile Directory being flipped
- Fix context menu previews of attachments not working
- Fix caret not scrolling into view when opening Compose
- Fix cells in the Drafts list being too small to tap
- Fix refresh failing when initial load failed
- Fix video controls in the gallery being too close to the edge of the screen
- Fix error when decoding malformed notifications
- Fix reblog with visibility not being available on Hometown instances
- Fix visibility dropdown being shown in confirm reblog alert even when unavailable
- Fix confirm reblog alert not adjusting to Dynamic Type
- Fix layout issues with replies on Compose screen
- macOS: Fix GIFs dragged from Finder posting static images

Known Issues:
- Drag/drop to add attachments when composting a post does not work

## 2022.1 (44)
Features/Improvements:
- Dynamic Type support
- Improve performance when displaying statuses with large numbers of custom emojis
- Add preference for default reply visibility
- Add preference to turn off blurring media in posts with content warnings

Bugfixes:
- Fix drawing background flashing between black/white in dark mode
- Fix undo scroll-to-top not working in release builds
- Fix favorite and reblog menu actions not working
- Fix avatar in compose being wrongly aligned on short statuses
- Fix posts that are tall but have few characters not getting collapsed
- Fix crash when profile screen is closed for the profile loads

## 2022.1 (43)
Features/Improvements:
- Re-add undo scroll-to-top by tapping the status bar a second time
- Convert hashtag/list/instance timelines to use new timeline implementation
- Clarify warning on Post Content Type preference

Bugfixes:
- Fix crash when refreshing profile before it loaded
- Fix crash when tapping Load More when infinite scrolling is disabled
- Fix crash when profile screen is closed before loading finishes
- Fix having to tap Cancel twice to dismiss Find Instance screen

## 2022.1 (42)
Features/Improvements:
- Add automatic crash reporting
- Tweak spacing on timeline statuses

Bugfixes:
- Fix status collapse/expand not animating on profiles
- Fix crash when opening profile for unloaded account (e.g., by tapping mentions)
- macOS: Add workaround for Follow/Unfollow menu item never loading

## 2022.1 (41)
Features/Improvements:
- Rewrite profile screens to use new timeline implementation
	- Disable Infinite Scrolling preference (Preferences -> Digital Wellness) now applies to profiles
	- Improve behavior when switching tabs on profiles
- Improve pointer interaction on timeline status cells

Bugfixes:
- Fix crash when loading images in certain circumstances
- Fix gallery dismissal leaving status bar hidden and breaking future gallery dismisses
- Fix timeline scroll position changing after dismissing gallery
- Fix images flickering when switching back to the Home tab
- Fix crash reporter being dismissed when sending email is cancelled
- Fix crash when long pressing Send Report button in crash reporter on iPad
- Fix Live Text controls not hiding when other gallery controls are hidden
- Fix replies appearing multiple times in Drafts list
- Fix crash when displaying blur hash images on Pleroma

## 2022.1 (40)
Bugfixes:
- Fix selecting reblogged statuses in the timeline
- Fix links/mentions/hashtags in the timeline not being tappable
- Fix mentions from Misskey opening in the browser rather than the profile screen
- Fix crash when leaving timeline tab before it finished loading
- Fix status cells in the timeline not deselected when tapped in split navigation mode on iPad
- Fix keyboard shortcuts not working on iPad

## 2022.1 (39)
This is a(nother) hotfix for the previous build. Their changelogs are included below.

Bugfixes:
- Fix instance selector screen crashing on iOS 15

## 2022.1 (38)
This is a hotfix for the previous build. Its changelog is included below.

Bugfixes:
- Fix sensitive attachments not being hidden on the timeline
- Fix timeline descriptions appearing repeatedly
- iPadOS: Fix occasional crash when hovering over text

## 2022.1 (37)
This is the first build with the rewritten/rearchitected timeline screen. In future builds, this will roll out to the notifications and profile screens as well, but for now it's only used in the home tab. If you encounter crashes or errors, please report them. If you see a blue error bubble pop up, you can long-press it to send an error report.

Features/Improvements:
- Display error messages when favoriting/reblogging fails

Bugfixes:
- iOS 15: (hopefully) fix lock-related crash
- Fix crash when loading indicator is shown multiple times

Known Issues:
- Videos played from the timeline do not enter picture-in-picture mode when backgrounding the app
- Status expand/collapse animations on other screens do not match timelines

Other:
- X-Callback-URL support has been removed

## 2022.1 (36)
This build is a hotfix for a crash when refreshing on Pixelfed.

## 2022.1 (35)
Features/Improvements:
- Add loading indicator to timelines/notifications/profiles
- Show status preview in reblog confirmation dialog (Preferences -> Behavior -> Require confirmation Before Reblogging)
- Add reblogging with unlisted/private visibility (requires reblog confirmation to be enabled)
- Fix controls not hiding on iPhone 14 Pro
- Improve account switching animation

Bugfixes:
- Fix crash when resizing window on iPad
- Fix poll vote count displaying random number
- Fix crash when opening emoji picker on instances that have duplicate emojis

## 2022.1 (33)
Features/Improvements:
- Show notifications when subscribed to other people's posts
- Use context menu for filter/sort in Profile Directory
- Enable data detectors (flight numbers, addresses, shippment numbers, phone numbers, currency (iOS 16), and physical units (iOS 16)) for the main status in Conversation
- iPadOS: Two column navigation
  - In potrait orientation with the sidebar hidden, or in landscape, Tusker uses two column navigation on iPad
  - Selecting something will open a second column in which navigation takes place
  - The second column can be closed from its top level
  - You can drill down farther inside the second column
  - Selecting a different item in the first column replaces the second column
- iPadOS: Move Trending Hashtags/Links to Explore screen (formerly Search)
  - Trending Statuses and Profile Directory will also be moved in a future version
- iPadOS: Add context menu action for deleting drafts
- iOS 16: Add Live Text to images in the gallery view
- iOS 16: Show favorite/reblog context menu actions
- iOS 16: Show full size previews when long-pressing attachments on the Compose screen
- iOS 16: Show formatting actions in edit menu on Compose screen

Bugfixes:
- Fix attachments on Pleroma not being served as the correct content type
- Fix not being able to open some hashtags with non-ASCII characters
- Fix crash when leaving the app shortly after opening it
- Fix crash when loading notifications on Pixelfed
- Fix crash due to retain cycle when changing preferences
- iPadOS: Fix crash when opening a conversation in a new window

## 2022.1 (31)
Bugfixes:
- Fix not being able to post attachments with descriptions
- Fix potential crash when displaying certain notifications
- More detailed error message when decoding invalid URLs

## 2022.1 (30)
Features/Improvements:
- Add fast account switching on iPad
- Add "Add Account" option to fast account switcher
- Show "# more replies" indicator in conversation in more circumstances
- When refreshing notifications, new ones are grouped with existing notifications
- Add subtitles to explain post visibility options
- Improve error messages when posting a video fails
- Display error messages instead of crashing when certain actions fail

Bugfixes:
- Fix Shortcuts actions not working in some circumstances
- Fix CW field growing wider than the screen
- Fix saved hashtags not persisting
- Fix not being able to long-press error-message bubbles
- Fix follow context menu item not updating after following
- Fix not being able to log in to certain Pixelfed instances
- Fix crash when closing the app
- Fix crash when loading profile screen
- Fix crash when refreshing polls
- Fix crash when poll voting fails
- Fix crash when accepting/rejecting a follow request fails
- Fix saved hashtags being sorted with case-sensitivity
- Fix multiple lines of text with emojis getting squashed together
- iPad: Fix Shortcuts actions showing wrong window type
- Mac: Fix Cmd+N shortcut not opening Compose window
- iPad/Mac: Fix Send Message action not mentioning account

## 2022.1 (27)
Features/Improvements:
- Add emoji picker button to Compose screen toolbar
- Preference to disable reply/like/reblog/more buttons on statuses in the timeline
- iPad: Sidebar toggle button

Bugfixes:
- Fix crash when displaying malformed statuses

## 2022.1 (26)
This build contains hotfixes for several crashes that may occur when logged-in to a Pixelfed account.

## 2022.1 (25)
Features/Improvements:
- Improve error reporting for non-crash errors
  - Long-press on the blue error bubble to send a report
- Improve error feedback during login process
- Add Trending Post and Trending Links on Mastodon 3.5
- Add Digital Wellness preference to disable Discover
- Basic support for GotoSocial
- Reduce app file size

Bugfixes:
- Fix all statues appearing as pinned on Pixelfed
- Fix crash when refreshing My Profile
- Fix My Profile never loading in some circumstances
- Fix crash the first time the attachment picker is opened
- Fix crash when closing certain screens
- Fix certain links in posts not being detected 

## 2022.1 (24)
Features/Improvements:
- Local only posts (Glitch/Hometown)
  - Show indicator for local only posts
  - Add local only option to Compose screen
- Add extend selection button to asset picker when the limited library was used
- Improve profile directory UI
- Improve scrolling performance with large attachments on older devices

Bugfixes:
- Fix crash when closing Preferences
- Fix crash when posting attachment fails
- Fix scrolling through compose autocomplete suggestions dismissing keyboard
- Only show Mute action on your own posts

## 2021.1 (23)
Features/Improvements:
- Synchronize GIF playback through animations and in gallery
  - Known Issue: This does not currently work with GIFVs used by Mastodon instances.

Bugfixes:
- Fix crash when a conversation fails to load
- Fix gallery dismissal breaking public timelines
- Fix gallery dismissal going in the wrong direction when the gesture was started slowly

## 2021.1 (22)
This is the first public beta build of Tusker, so if you're just joining us, welcome! Not too many new features this build, mostly bugfixes, so test everything and generally use the app.

Features/Improvements:
- Add timeline descriptions the first time you view federated/local
- Show messages when loading posts fails or when there are no newer posts

Bugfixes:
- Fix crash after editing lists
- Fix crash when refreshing before anything is loaded
- Fix crash when fetching recommended instances fails
- Fix crash when replying to posts with code formatting
- Fix crash when changing preferences after switching accounts

## 2021.1 (21)
This is a quick follow-up to the previous build with fixes for a couple major crashes. Unfortunately, due to a bug in iOS 14, the Disable Infinite Scrolling preference now requires the iOS 15 beta to use. It may return in a future build if I can find a workaround, but it's disabled in the meantime.

Features/Improvements:
- iPadOS 15: Add Open in New Window context menu action to sidebar items

Bugfixes:
- Fix crash when editing accounts in a list
- Fix crash when refreshing timeline on iOS 14
- Fix(ish) crash when opening collapsed status with Disable Infinite Scrolling active on iOS 15

## 2021.1 (20)
This is a big one! In addition to a bunch of fixes for anyone on the iOS 15 beta, there are a couple of big ticket features, including the Open in Tusker action extension and the Disable Infinite Scrolling preference.

Features/Improvements:
- Add Open in Tusker action extension
  - Quickly search for any URL in Tusker
  - In a share sheet, scroll to the bottom, tap "Edit Actions..." and turn on the "Open in Tusker" action
- Add Digital Wellness preference to disable infinite scrolling
- Add fast account switching indicator to My Profile tab
- Improve VoiceOver accessibility of polls and timeline statuses
- iPadOS: Create multiple main windows for different accounts by dragging from an account in Preferences
- iPadOS: Delete attachments on Compose screen by right-clicking and selecting Delete
- iPadOS 15: Add Open in New Window context menu action to most things
- iPadOS 15: Allow dragging the Compose sheet into a separate window

Bugfixes:
- Fix being unable to commit previewed account from timeline status
- Fix crash when searching fails
- Fix poll option percentages being cut off
- Fix polls not collapsing inside CWs
- Fix More button on profiles not being accessible with VoiceOver
- Fix VoiceOver reading profile fields in incorrect order
- Fix gallery animations jittering on devices with square screens (iPads, non-notched iPhones)
- Fix CW text jumping around post collapse animation
- iOS 15: Fix crash due when showing Draw Something screen in Compose
- iPadOS 14/iOS 15: Fix navigation bar turning transparent after opening the attachment gallery
- iPadOS 14/iOS 15: Fix drag-selecting poll options initiating a status cell drag interaction
- iPadOS: Fix crash when loading a previously-opened conversation window
- iPadOS 15: Fix showing Compose screen when keyboard focus moves through the sidebar

Known Issues:
- Disable Infinite Scrolling preference only affects timelines, not notifications or profiles
- iPadOS 15: The Compose sheet cannot be dismissed by swiping down
- iPadOS 15: Keyboard focus is stuck in the sidebar

## 2021.1 (19)
This is an emergency fix for Tusker breaking when connecting to Mastodon instances on 3.4.0rc1.

Bugfixes:
- Fix crash when connecting to Mastodon 3.4.0rc1
- Fix crash when loading notifications fails

## 2021.1 (18)
Polls! They're finally here. There will likely be another build in the next several weeks to polish some things off before WWDC, so if you've encountered any issues, now's the time to let me know :)

Features/Improvements:
- Show polls on posts
- Add authoring polls to Compose screen
- Add poll completed notifications
- Add preference for requiring confirmation before reblogging

Bugfixes:
- Fix cursor movement not working in Compse text field when an emoji was entered
- Fix several crashes related to network requests failing
- Show assets in attachment picker immediately after permissions is initially granted
- Fix crash when tapping non-HTTP(S) link with the In-App Safari preference enabled

Known Issues:
- Polls with between 23h30m and 24h left show as "0 weeks remaining"

## 2021.1 (17)
The main improvement this build is a complete overhaul of the Conversation screen, along with fixes for a few different crashes.

Features/Improvements:
- Group replies by thread on Conversation screen
- Adding Trending Hashtags and Profile Directory to Explore screen (Mastodon only)

Bugfixes:
- Fix crash when editing List members
- Fix crash when re-opening Preferences after switching accounts
- Fix crash when refreshing profiles in some circumstances

## 2021.1 (16)
This build fixes a number of crashes and significantly improves performance on older devices.

Features/Improvements:
- Significantly improve performance when scrolling through timelines

Bugfixes:
- Fix crash when timeline or profile went offscreen
- Fix crash when refreshing profile too quickly
- iPadOS: Fix secondary windows not respecting theme preference
- Fix refreshes breaking after a refresh which did not return new results

## 2020.1 (15)
There are a whole bunch of new features in this release, in addition to a slew of bugfixes. The big ticket items are multi-window support on iPadOS and fast account switching on iPhone (fast account switching will be supported on iPads in a future build).

Features/Improvements:
- Add fast account switching on iPhone
  - Long-press on the My Profile tab and drag up to select another account
  - Add account switching animation
- iPadOS: Add multiple windows
  - Drag and drop statuses and accounts on timelines into auxiliary windows
  - Drag and drop sidebar items into new windows
  - Drag and drop Compose drafts into new windows
- Add key commands
  - ⌘R to refresh timelines
  - ⌘N to Compose a post
  - ⌘B/⌘I text formatting on Compose screen
  - ⇧⌘[/⇧⌘] to switch between sub-tabs
  - iPadOS: ⌘1/⌘2/⌘3/⌘4/⌘5 to select sidebar items
- Show link cards on statuses
- Add Grayscale Images preference to Digital Wellness
- Add preference for applying opposite collapse behavior for specific keywords

Bugfixes:
- Fix statuses not appearing on My Profile until scrolling
- Fix crashes when scrolling through timelines
- Fix logging into PixelFed instances
  - Interacting with PixelFed instances remains only partially supported
- Enlarge expand/collapse button tap area
- Fix cursor disappearing behind keyboard when typing attachment descriptions
- Fix crash when viewing custom emojis with spaces in their URLs
- Fix split view not working in landscape on Plus/Max iPhones
- Minor performance improvements

## 2020.1 (13)
This is another quick build to fix a couple of severe issues on the Compose screen.

Features/Improvements:
- When composing posts, ensure the cursor is always visible and does not scroll below the keyboard while typing

Bugfixes:
- Fix builtin iOS keyboard suggestions not working in text fields on the Compose screen
- Fix crash when ending dictation in the CW field
- Fix broken layout on the Compose when replying to certain posts

## 2020.1 (12)
This build is a hotfix for the issue of being unable to login to certain instances. The changelog for the previous build is included below.

## 2020.1 (11)
This release is primarily focused on bug fixes with the one key feature of autocomplete suggestions when typing in the Compose screen. It also fixes an issue on the various new sizes of iPhone 12, so if you're getting a new device, make sure to update.

Features/Improvements:
- Add autocompletion on Compose screen
  - Autocomplete provides suggestions for @-mentions, hashtags, and emojis as you're typing in the post body
  - Provides suggestions for emojis as you're typing in the CW field
  - Type a colon and expand the emoji suggestions to view all custom emoji on your instance
  - Hashtag suggestions prioritize trending and saved hashtags, in addition to searching all hashtags on your instance
  - Account suggestions prioritize accounts that you follow or that follow you, as well as searching all accounts known to your instance
- Show custom emojis in users' display names in follow, favorite, and reblog notifications
- Enable picture-in-picture playback of video attachments
  - iOS 14: Automatically enter picture-in-picture when closing the app while a video is playing
- Correctly positiong gallery controls on iPhone 12-family devices
- Round corners of the avatar on the My Profile tab icon
- Remove extraneous U+FFFC characters inserted by dictation when posting
- Add swipe to remove accounts in Preferences

Bugfixes:
- Fix not being able to tap placeholders in Compose
- Fix broken layout on Compose screen when replying to very long posts
- Fix crash when opening Compose or My Profile too quickly after launch
- Upload photos taken with the in-app camera as JPEGs instead of PNGs
  - Fixes an issue where Mastodon would incorrectly believe the file size to be too large
- Fix crash when using home screen shortcuts
- Disable rotating into landscape on iPhone on iOS 14
- Fix assorted other crashes and memory leaks

## 2020.1 (10)
This build is a hotfix for a couple pressing issues. The changelog for the previous build is included below.

Bugfixes:
- Fix crash when opening Preferences while signed in with a deleted account
- Fix visibility and content warning not being copied when replying to a post

## 2020.1 (9)
The marquee feature of this build is the new and improved Compose screen. It's been rewritten to use SwiftUI, is significantly more resilient to data loss, and now shows the toolbar when the main text field is not focused. It also turns out Apple is surprise-releasing iOS 14 very soon (or possibly already has, depending when you're reading this). For those who were not already on the beta train, iOS 14 brings a number of new features including a sidebar on iPadOS and lots and lots of context menus (a home screen widget is coming Soon™).

Known Issues:
- Pasting images to create attachments when composing a post is not currently supported due to an iOS bug (#109)
- Full-size previews do not display in context menus for attachments on the Compose screen due to an iOS issue (#110)

Features/Improvements:
- Rewrite Compose screen using SwiftUI
  - Prevent draft posts being lost if the app crahes or is killed by the system while composing
  - Show toolbar while post content is not being edited
  - Save post visibility in drafts
  - Move Draw Something action out of the context menu
  - iOS 14: Use context menus for setting post visibility
- Show BlurHash previews for attachments on Mastodon
- Add Expand All Content Warnings preference (Preferences -> Behavior)
- Add Collapse Long Posts preference (Preferences -> Behavior)
- Improve image gallery opening animation
- Use fade in/out animations for opening/closing gallery and attachment picker when the Reduce Motion system setting is enabled
  - iOS 14: Also requires the "Prefer Cross Fade" setting be enabled
- Slightly reduce default status font sizes
- Add "Direct Message" context menu action to Compose button on profile screen
- Allow viewing attachments and navigating through posts/accounts on instance public timelines

Bugfixes:
- Fix errors when uploading attachments not displaying
- Fix attachments not posting in the correct, user-specified order
- Fix accounts displaying with outdated information (avatars, display names, etc.)
- Fix Compose not showing button on profile screen
- Fix navigation title not being set on profile screen
- Fix follow notifications not showing names for users without display names set
- iPadOS 14: Fix crash when resizing app in split view mode

## 2020.1 (8)
This is just an emergency build to fix crashes on iOS 13 when selecting attachments. The changelog of the previous build is included below.

Features/Improvements:
- Enlarge tap targets on status reply/favorite/reblog/more buttons
- Disable automatic GIF playback when Low Power Mode is enabled
- Show custom emoji in user profile field names

Bugfixes:
- Fix crash when attempting to add attachments on iOS 13
- Fix potential crashes

## 2020.1 (7)
This is the first update since WWDC and the introduction of iOS 14. As such, most of the focus has been on fixing iOS 14-specific problems. However, there are still a couple new features, both for those on the iOS 14 beta and those not.

Features/Improvements:
- Add toggle between Posts, Posts and Replies, and Media on user profiles
  - Remove 'Show Replies in Profiles' preference
- Limit link preview animation to only link text
- Add additional context menu actions for statuses, accounts, and hashtags
- Add semi-translucent background to image descriptions, so they're legible against light images
- iPadOS 14: Add sidebar
  - When using multitasking on iPad and switching in and out of "compact" mode, the active tab as well as the navigation history for all tabs will be transferred between the sidebar and tab bar modes.
- iOS 14: Use context menus on status/account '...' buttons
- iOS 14: Replace 'More' status swipe action with 'Share'

Bugfixes:
- Fix crash when attempting to change post visibility on iPad
- Fix attachment view corners not being rounded
- Fix crash when viewing instance public timelines
- Fix Preferences button not appearing on My Profile tab
- Fix tapping current tab bar item not scrolling to top
- Fix crash showing audio attachments on Mastodon
- Fix timeline refreshing forever
- Set app category (fixes usage not being categorized correctly under Screen Time)
- iOS 14: Fix crash when searching for instances
- iOS 14: Fix crash when displaying accounts with no pinned posts
- iOS 14: Fix crash when displaying search results

## 2020.1 (6)
This is the pre-WWDC update with lots of bugfixes and some small features. There will likely be another build this week to fix any pressing issues that arise from iOS 14.

Features/Improvements:
- Add mute/unmute conversation status action
- iPadOS: Add pointer interactions to remove attachment button, gallery view share/dismiss buttons
- Disable reblog button for direct/followers-only posts
  - On Pleroma, the reblog button is still enabled for your own followers-only posts to match Pleroma's "Boost to original audience" feature.
- Add preference to always display status visibilities below account avatars
- Add preference to show reply indicators for statuses in timelines
- Show share/dismiss controls and image description for gifv attachments
  - 'Share' is currently disabled for gifv attachments, it will be enabled in a future build
- Add crash report helper
  - If the app detects that it crashed the last time it was running, it will allow you to review the crash report and email it to me
- Add Recognize Text context menu option for images on the Compose screen
  - This uses iOS' builtin Vision framework to perform on-device OCR and generate an image description from the recognized text
- Tweak attachment previews to always have a 16:9 aspect ratio

Bugfixes:
- Fix account/status More actions not working
- Improve share sheet loading speed
- Fix crash when loading bookmarks
- Prompt for Photos access before showing photo picker. Prevents empty sheet displaying.
- Fix profile fields not displaying and improve layout
- Fix profile header image not displaying the first time an account is loaded
- Don't show Follow action for your own account
- Fix attachments on the Compose screen being cut-off above the home indicator  on iPhone X-style devices
- Fix audio being played by other apps pausing when displaying a gifv attachment on Mastodon


## 2020.1 (5)
The main focus of this update has been switching to using CoreData internally to cache/synchronize the most up-to-date versions of all statuses. Currently, this does not provide any new functionality, however, it lays the groundwork for several significant features coming in the future, including multiple window support on iPadOS and state restoration/persistence between launches.

Even though there aren't a huge number of new features in this build, a great deal has changed under the hood. As such, this build may suffer somewhat in the stability department. Please bear with me and report any issues you encounter; you can send me a message on the fediverse, email me at me@shadowfacts.net, or file an issue on the project issue tracker at https://git.shadowfacts.net/shadowfacts/Tusker/issues. Thank you!

Features:
- iPadOS: Add pointer interactions to status action buttons and profile header button
- iPadOS: Allow scrolling w/ trackpad/magic mouse to dismiss attachment gallery
- iPadOS: Enable interactive push gesture with trackpad/magic mouse
- Add drawing attachments using PencilKit
  - Long-press to open context menu on the 'Add Attachment' button on the Compose screen, select 'Draw Something'
  - Supports Apple Pencil on iPad, including tilt and pressure sensitivity
- Add avatar and instance domain in accounts switcher in Preferences
- Show gifv attachments on Mastodon
  - Currently doesn't show attachment description or share/close buttons
- Add 'Clear Cache' option to Preferences -> Advanced for debugging

Bugfixes:
- Fix size of attachment previews in context menu
- Fix previewing audio/video attachments
- Fix incorrect image size during attachment expand/shrink animation
- Prevent avatars in grouped action notification from overflowing the cell and hiding the timestamp
- Fix text in conversation main statuses not being de-selectable
- Fix scroll-to-top sometimes not scrolling all the way to the top
- Fix account profile descriptions being squashed in the follow notification account list


