//
//  TuskerSceneDelegate.swift
//  Tusker
//
//  Created by Shadowfacts on 10/31/22.
//  Copyright © 2022 Shadowfacts. All rights reserved.
//

import UIKit

protocol TuskerSceneDelegate: UISceneDelegate {
    var rootViewController: TuskerRootViewController? { get }
    
    func handleStatusBarTapped(xPosition: CGFloat) -> StatusBarTapActionResult
}

enum StatusBarTapActionResult {
    case `continue`
    case stop
}

extension TuskerSceneDelegate {
    func handleStatusBarTapped(xPosition: CGFloat) -> StatusBarTapActionResult {
        if let rootViewController {
            let converted = rootViewController.view.convert(CGPoint(x: xPosition, y: 0), from: nil)
            return rootViewController.handleStatusBarTapped(xPosition: converted.x)
        }
        return .continue
    }
}
